/**
 * Roundcube Treelist Widget
 *
 * This file is part of the Roundcube Webmail client
 *
 * @licstart  The following is the entire license notice for the
 * JavaScript code in this file.
 *
 * Copyright (c) 2013-2014, The Roundcube Dev Team
 *
 * The JavaScript code in this page is free software: you can
 * redistribute it and/or modify it under the terms of the GNU
 * General Public License (GNU GPL) as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option)
 * any later version.  The code is distributed WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU GPL for more details.
 *
 * As additional permission under GNU GPL version 3 section 7, you
 * may distribute non-source (e.g., minimized or compacted) forms of
 * that code without the copy of the GNU GPL normally required by
 * section 4, provided you include this license notice and a URL
 * through which recipients can access the Corresponding Source.
 *
 * @licend  The above is the entire license notice
 * for the JavaScript code in this file.
 *
 * @author Thomas Bruederli <roundcube@gmail.com>
 * @requires jquery.js, common.js
 */
function rcube_treelist_widget(ia,g){var J,K,L;function A(a,b,d){var c;if(c=h[a]){c.collapsed="undefined"==typeof d||d;var f=l(c.id,!0);f.attr("aria-expanded",c.collapsed?"false":"true");f.children("ul").first()[c.collapsed?"hide":"show"]();f.children("div.treetoggle").removeClass("collapsed expanded").addClass(c.collapsed?"collapsed":"expanded");u.triggerEvent("toggle",c);if(b&&c.children)for(f=0;f<c.children.length;f++)A(c.children[f].id,b,d);u.triggerEvent(c.collapsed?"collapse":"expand",c);b=
c.collapsed;g.save_state&&window.rcmail&&(d="treelist-"+S,v||(v=rcmail.local_storage_get_item(d,{})),v[a]!=b&&(v[a]=b,rcmail.local_storage_set_item(d,v)))}}function T(a,b){A(a,b,!1)}function F(a){if(!1!==u.triggerEvent("beforeselect",h[a])&&(k&&(l(k,!0).removeClass("selected").removeAttr("aria-selected"),m&&l(k).removeClass("selected").removeAttr("aria-selected"),k=null),a)){var b=l(a,!0);b.length&&(b.addClass("selected").attr("aria-selected","true"),k=a,m&&l(a).addClass("selected").attr("aria-selected",
"true"),U(b));u.triggerEvent("select",h[a])}}function V(){return k}function W(a,b){return l(a,b).get(0)}function X(a,b){var d,c,f=a.get(0).id,r=a.children().first().text().toUpperCase();a.parent().children("li"+b).each(function(a,b){0==a&&(d=b);if(b.id!=f)if(b.id!=f&&r>=$(b).children().first().text().toUpperCase())c=b;else return!1});c?a.insertAfter(c):d&&d.id!=f&&a.insertBefore(d);p=G(e,0)}function Y(a,b){a=String(a).toLowerCase();if(!a.length)return B();if(a==C&&!b)return 0;var d=[],c=function(b){$.each(b,
function(b,f){if(!f.virtual&&!f.deleted&&0<=String(f.text).toLowerCase().indexOf(a)&&0>d.indexOf(f.id)){b=l(f.id);if(b.data("filtered"))return;$("<li>").attr("id",b.attr("id")+"--xsR").attr("class",b.attr("class")).addClass("searchresult__").append(b.children(":not(div.treetoggle,ul)").clone(!0,!0)).appendTo(e);d.push(f.id)}f.children&&f.children.length&&c(f.children)})};m&&($(e).children("li.searchresult__").remove(),m=!1);$(e).children("li").hide().removeClass("selected");c(p);m=!0;u.triggerEvent("search",
{query:a,last:C,count:d.length,ids:d,execute:b||!1});C=a;return d.count}function B(){M&&M.val("");$(e).children("li.searchresult__").remove();$(e).children("li").filter(function(){return!$(this).data("filtered")}).show();m=!1;u.triggerEvent("search",{query:!1,last:C});C="";k&&F(k)}function z(a,b,d){if(!a.deleted){var c=$("<li>").attr("id",g.id_prefix+(g.id_encode?g.id_encode(a.id):a.id)).attr("role","treeitem").addClass((a.classes||[]).join(" ")).data("id",a.id);d?(d.replaceWith(c),b&&c.appendTo(b)):
c.appendTo(b);"string"==typeof a.html?c.html(a.html):"object"==typeof a.html&&c.append(a.html);a.text||(a.text=c.children().first().text());a.virtual&&c.addClass("virtual");a.id==k&&c.addClass("selected");if(a.children&&a.children.length)for(c.attr("aria-expanded",a.collapsed?"false":"true"),$('<div class="treetoggle '+(a.collapsed?"collapsed":"expanded")+'">&nbsp;</div>').appendTo(c),b=$("<ul>").appendTo(c).attr("class",a.childlistclass).attr("role","group"),a.collapsed&&b.hide(),d=0;d<a.children.length;d++)a.children[d].level=
a.level+1,z(a.children[d],b);return c}}function G(a,b){var d=[];a.children("li").each(function(a,f){f=$(f);var c=f.children("ul"),e={id:n(f),classes:String(f.attr("class")).split(" "),virtual:f.hasClass("virtual"),level:b,html:f.children().first().get(0).outerHTML,text:f.children().first().text(),children:G(c,b+1)};c.length&&(e.childlistclass=c.attr("class"));e.children.length&&(void 0===e.collapsed&&(e.collapsed="none"==c.css("display")),a=Z(e.id,e.collapsed),void 0!==a&&(e.collapsed=a,c[a?"hide":
"show"]()),f.children("div.treetoggle").length||$('<div class="treetoggle '+(e.collapsed?"collapsed":"expanded")+'">&nbsp;</div>').appendTo(f),f.attr("aria-expanded",e.collapsed?"false":"true"));f.hasClass("selected")&&(f.attr("aria-selected","true"),k=e.id);f.data("id",e.id);f.attr("role","treeitem").attr("aria-level",e.level+1);e.virtual&&f.children("a:first").attr("tabindex","0");d.push(e);h[e.id]=e});a.attr("role",0==b?"tree":"group");return d}function aa(a){a.id&&(h[a.id]=a);for(var b=0;a.children&&
b<a.children.length;b++)aa(a.children[b])}function n(a){a=String(a.attr("id")).replace(new RegExp("^"+g.id_prefix||"%"),"").replace(/--xsR$/,"");return g.id_decode?g.id_decode(a):a}function l(a,b){a=g.id_encode?g.id_encode(a):a;return $("#"+g.id_prefix+a+(m&&!b?"--xsR":""),e)}function U(a){var b=e.parent(),d=b.scrollTop(),c=a.offset().top-b.offset().top;(0>c||c+a.height()>b.height())&&b.scrollTop(c+d)}function Z(a){if(g.save_state&&window.rcmail)return v||(v=rcmail.local_storage_get_item("treelist-"+
S,{})),v[a]}function ba(a,b,d){var c=a[0>b?"prev":"next"]();0<b&&!d&&a.children("ul[role=group]:visible").length?a.children("ul").children("li:first").find("a:first").focus():0>b&&!d&&c.children("ul[role=group]:visible").length?c.children("ul").children("li:last").find("a:first").focus():c.length&&c.find("a:first").focus().length||(a=a.parent().closest("li[role=treeitem]"),a.length&&(0>b?a.find("a:first").focus():ba(a,b,!0)))}function N(a){if(a||!x){x=!0;var b,d=e.offset();ca=bw.ie?0:window.pageYOffset;
y=e.parent().scrollTop();d.top+=y;J=d.left;K=d.top;L=d.left+e.width();da=d.top+e.height();H=[];for(var c in h)a=l(c),(a=a.children().first().get(0))&&(b=a.offsetHeight)&&(d=$(a).offset(),d.top+=y,H[c]={x1:d.left,y1:d.top,x2:d.left+a.offsetWidth,y2:d.top+b,on:c==w});e.height()>e.parent().height()&&e.parent().mousemove(function(a){var b=0;a=rcube_event.get_mouse_pos(a);a.y-=e.parent().offset().top;25>a.y&&0<y?b=-1:a.y>e.parent().height()-25&&(b=1);x&&0!=b?q||(q=window.setTimeout(function(){ea(b)},g.scroll_delay)):
q&&(window.clearTimeout(q),q=null)}).mouseleave(function(){q&&(window.clearTimeout(q),q=null)})}}function fa(){x&&(x=!1,q=null,t&&(clearTimeout(t),w=t=null),$("li.droptarget",e).removeClass("droptarget"))}function ea(a){if(x){var b=y;e.parent().get(0).scrollTop+=g.scroll_step*a;y=e.parent().scrollTop();q=null;y!=b&&(q=window.setTimeout(function(){ea(a)},g.scroll_speed))}}function ha(a,b){var d=bw.ie?-document.documentElement.scrollTop:ca,c=e.parent().scrollTop(),f=null;a.top=a.y+c-d;if(a.x<J||a.x>=
L||a.top<K||a.top>=da)return b&&$("li.droptarget",e).removeClass("droptarget"),f;for(var r in H)d=H[r],a.x>=d.x1&&a.x<d.x2&&a.top>=d.y1&&a.top<d.y2?(f=h[r],f.children&&f.children.length&&f.collapsed&&g.autoexpand&&w!=r?(t&&clearTimeout(t),w=r,t=setTimeout(function(){T(w);N(!0);w=null;D&&$.ui.ddmanager.prepareOffsets($.ui.ddmanager.current,null)},g.autoexpand)):t&&w!=r&&(clearTimeout(t),t=w=null),g.check_droptarget(f)?(b&&(l(r).addClass("droptarget"),d.on=!0),f=r):f=null):d.on&&(l(r).removeClass("droptarget"),
d.on=!1);return f}function O(a){a||(a={});if("string"==$.type(a))return"destroy"==a&&(D=null),$("li:not(.virtual)",e).droppable(a),this;P=a;var b=$.extend({greedy:!0,tolerance:"pointer",hoverClass:"droptarget",addClasses:!1},a);b.activate=function(b,c){N();D=c;a.activate&&a.activate(b,c)};b.deactivate=function(b,c){fa();D=null;a.deactivate&&a.deactivate(b,c)};b.over=function(b,c){ha(rcube_event.get_mouse_pos(b),!1);a.over&&a.over(b,c)};$("li:not(.virtual)",e).droppable(b);return this}function Q(a){a||
(a={});if("string"==$.type(a))return"destroy"==a&&(I=null),$("li:not(.virtual)",e).draggable(a),this;R=a;a=$.extend({appendTo:"body",revert:"invalid",iframeFix:!0,addClasses:!1,cursorAt:{left:-20,top:5},create:function(a,d){I=d},helper:function(a){return $("<div>").attr("id","rcmdraglayer").text($.trim($(a.target).first().text()))}},a);$("li:not(.virtual)",e).draggable(a);return this}g=$.extend({id_prefix:"",autoexpand:1E3,selectable:!1,scroll_delay:500,scroll_step:5,scroll_speed:20,save_state:!1,
keyboard:!0,tabexit:!0,parent_focus:!1,check_droptarget:function(a){return!a.virtual}},g||{});var e=$(ia),p=g.data||[],h={},k=null,x=!1,m=!1,C="",E=!1;var da=L=K=J=void 0;var H=[],t,w,ca=0,y=0,q,v,D,I,R,P,S=e.attr("id")||g.id_prefix||"0",u=this;this.container=e;this.expand=T;this.collapse=A;this.select=F;this.render=function(){if(!1!==u.triggerEvent("renderBefore",p)){e.html("");for(var a=0;a<p.length;a++)p[a].level=0,z(p[a],e);u.triggerEvent("renderAfter",e)}};this.reset=function(a){F("");p=[];h=
{};x=!1;a?(R&&(I&&Q("destroy"),Q(R)),P&&(D&&O("destroy"),O(P)),p=G(e,0)):e.html("");B()};this.drag_start=N;this.drag_end=fa;this.intersects=ha;this.droppable=O;this.draggable=Q;this.is_draggable=function(){return!!I};this.update=function(a,b,d){var c,f,g=h[a];if(g){var k=l(a);var m=k.parent();if(b.id||b.html||b.children||b.classes||b.parent)b.parent&&(c=h[b.parent])?(m.closest("li").length&&(f=h[n(m.closest("li"))])&&(f.children=$.grep(f.children,function(a,b){return a.id!=g.id})),m=l(b.parent).children("ul").first(),
c.children||(c.children=[]),c.children.push(g)):void 0!==b.parent&&(m=e),$.extend(g,b),k=z(g,m,k);g.id!=a&&(delete h[a],h[g.id]=g);d&&X(k,"string"==typeof d?'[class~="'+d+'"]':"")}};this.insert=function(a,b,d){var c=b?h[b]:null;search_=m;h[a.id]||(state=Z(a.id,a.collapsed),void 0!==state&&(a.collapsed=state),c?(a.level=c.level+1,c.children||(c.children=[]),m=!1,c.children.push(a),b=l(b),1==c.children.length?(z(c,null,b),c=l(a.id)):c=z(a,b.children("ul").first()),search_&&(m=search_,c.is(":visible")||
$("<li>").attr("id",c.attr("id")+"--xsR").attr("class",c.attr("class")).addClass("searchresult__").append(c.children().first().clone(!0,!0)).appendTo(e))):(a.level=0,p.push(a),c=z(a,e)),h[a.id]=a,"object"==typeof a.html&&(h[a.id].html=l(a.id,!0).children()),d&&X(c,"string"==typeof d?'[class~="'+d+'"]':""))};this.remove=function(a){var b;if(b=h[a]){var d=l(a,!0);var c=d.parent();d.remove();b.deleted=!0;delete h[a];m&&l(a,!1).remove();c.children().length||(c.parent().find("div.treetoggle").remove(),
c.remove());return!0}return!1};this.get_item=W;this.get_node=function(a){return h[a]};this.get_selection=V;this.get_next=function(){var a;if(k&&(a=l(k))){var b=a.children("ul").children("li:first");if(b.length)return n(b);b=a.next();if(b.length)return n(b);for(;(a=a.parent("ul").parent("li"))&&a.length;)if(b=a.next(),b.length)return n(b)}};this.get_prev=function(){var a;if(k&&(a=l(k))){var b=a.prev();var d=b.find("li:last");if(d.length)return n(d);if(b.length)return n(b);a=a.parent().parent();if(a.length&&
a.is("li"))return n(a)}};this.get_single_selection=V;this.is_search=function(){return m};this.reset_search=B;if(e.length){g.data?aa({children:p}):p=G(e,0);k&&U(l(k,!0));e.attr("role","tree").on("focusin",function(a){E=!0}).on("focusout",function(a){E=!1}).on("click","div.treetoggle",function(a){var b=n($(this).parent()),d;(d=h[b])&&A(b,void 0,!d.collapsed);a.stopPropagation()}).on("click","li",function(a){if($(a.target).is("input"))return!0;var b=g.selectable?h[n($(this))]:null;b&&!b.virtual&&(F(b.id),
a.stopPropagation())}).on("mousedown","a",function(a){var b=$(a.target),d=h[n(b.closest("li"))];if(d&&d.virtual&&!b.attr("href"))return a.preventDefault(),a.stopPropagation(),!1});if(g.searchbox){var M=$(g.searchbox).off("keyup.treelist").on("keyup.treelist",function(a){var b=rcube_event.get_keycode(a);rcube_event.get_modifier(a);switch(b){case 9:break;case 13:return Y(this.value,!0),rcube_event.cancel(a);case 27:B();break;case 38:case 37:case 39:case 40:break;default:Y(this.value,!1)}}).attr("autocomplete",
"off");M.parent().find("a.reset").off("click.treelist").on("click.treelist",function(a){B();return!1})}$(document.body).on("keydown",function(a){var b=a.target||{},d=rcube_event.get_keycode(a);if(!E||"INPUT"==b.nodeName&&38!=d&&40!=d||"TEXTAREA"==b.nodeName||"SELECT"==b.nodeName)return!0;switch(d){case 38:case 40:case 63232:case 63233:return b=g.keyboard?e.find(":focus").closest("li"):[],b.length&&ba(b,mod=38==d||63232==d?-1:1),rcube_event.cancel(a);case 37:case 39:var c;b=e.find(":focus").closest("li");
if(b.length&&(b=n(b),(c=h[b])&&c.children.length&&c.collapsed!=(37==d))){a=rcube_event.get_modifier(a)==SHIFT_KEY;var f;(f=h[b])&&A(b,a,!f.collapsed)}return!1;case 9:g.keyboard&&g.tabexit&&(f=rcube_event.get_modifier(a)==SHIFT_KEY?"first":"last",f=e.find("li[role=treeitem]:has(a)")[f]().find("a:"+f),f.length&&(a=e.parent().get(0)||{scrollTop:0},d=a.scrollTop||a.scrollY,f.focus(),a.scrollTop=d))}return!0});g.parent_focus&&e.parent(":not(body)").click(function(a){if($(a.target).is("input"))return!0;
!E&&k?$(W(k)).find(":focusable").first().focus():E||e.children("li:has(:focusable)").first().find(":focusable").first().focus()})}}rcube_treelist_widget.prototype.addEventListener=rcube_event_engine.prototype.addEventListener;rcube_treelist_widget.prototype.removeEventListener=rcube_event_engine.prototype.removeEventListener;rcube_treelist_widget.prototype.triggerEvent=rcube_event_engine.prototype.triggerEvent;
